using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Data.SqlClient;

public partial class _Default : System.Web.UI.Page 
{
    public DataTable GetDataTable(string query)
    {
        String ConnString = ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString;
        SqlConnection conn = new SqlConnection(ConnString);
        SqlDataAdapter adapter = new SqlDataAdapter();
        adapter.SelectCommand = new SqlCommand(query, conn);

        DataTable myDataTable = new DataTable();

        conn.Open();
        try
        {
            adapter.Fill(myDataTable);
        }
        finally
        {
            conn.Close();
        }

        return myDataTable;
    }

    public DataTable PivotTable(DataTable source)
    {
        DataTable dest = new DataTable("Pivoted" + source.TableName);

        dest.Columns.Add(" ");
        

        foreach (DataRow r in source.Rows)
            dest.Columns.Add(r[0].ToString());           

        for (int i = 0; i < source.Columns.Count - 1; i++)
        {
            dest.Rows.Add(dest.NewRow());
        }

        for (int r = 0; r < dest.Rows.Count; r++)
        {
            for (int c = 0; c < dest.Columns.Count; c++)
            {
                if (c == 0)
                    dest.Rows[r][0] = source.Columns[r + 1].ColumnName;
                else
                    dest.Rows[r][c] = source.Rows[c - 1][r + 1];
            }
        }

        dest.Columns.Add("Accept");
        dest.Columns.Add("Reject");        

        dest.AcceptChanges();
        return dest;
    }

    protected void RadGrid1_NeedDataSource1(object source, GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = PivotTable(GetDataTable("SELECT TOP 5 CustomerID, CompanyName, ContactName, ContactTitle, Address, PostalCode, City, Country FROM Customers"));
    }

    protected void RadGrid1_ColumnCreated(object sender, GridColumnCreatedEventArgs e)
    {
        if (e.Column.UniqueName == "Button1" || e.Column.UniqueName == "Button2")
        {
            GridBoundColumn column = ((Telerik.Web.UI.GridBoundColumn)(e.Column));
            column.ReadOnly = true;

        }
    }

    protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            (e.Item as GridDataItem)[(RadGrid1.MasterTableView.AutoGeneratedColumns[0] as GridBoundColumn).UniqueName].Font.Bold = true;
            (e.Item as GridDataItem)[(RadGrid1.MasterTableView.AutoGeneratedColumns[0] as GridBoundColumn).UniqueName].BackColor = System.Drawing.SystemColors.Control;
            (e.Item as GridDataItem)[(RadGrid1.MasterTableView.AutoGeneratedColumns[0] as GridBoundColumn).UniqueName].BorderColor = System.Drawing.Color.White;

            LinkButton ButtonAccept = new LinkButton();
            ButtonAccept.ID = "ButtonAccept";
            (e.Item as GridDataItem)["Accept"].Controls.Add(ButtonAccept);

            LinkButton ButtonReject = new LinkButton();
            ButtonReject.ID = "ButtonReject";
            (e.Item as GridDataItem)["Reject"].Controls.Add(ButtonReject);
        }
    }

    protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            LinkButton ButtonAccept = new LinkButton();
            ButtonAccept.ID = "ButtonAccept";
            (e.Item as GridDataItem)["Accept"].Controls.Add(ButtonAccept);
            ButtonAccept.CommandName = "Accept";
            ButtonAccept.Text = "Accept";

            LinkButton ButtonReject = new LinkButton();
            ButtonReject.ID = "ButtonReject";
            (e.Item as GridDataItem)["Reject"].Controls.Add(ButtonReject);
            ButtonReject.CommandName = "Reject";
            ButtonReject.Text = "Reject";
        }
    }   

    protected void RadGrid1_ItemCommand(object source, GridCommandEventArgs e)
    {
        if (e.CommandName == "Accept")
        {
            //your custom action here
        }
        else if (e.CommandName == "Reject")
        {
            //your custom action here
        }
    }    
  
}